/***************************************************************************
                          apollonsearchitemview.cpp  -  description
                             -------------------
begin		: Dec 05 2003
copyright	: (C) 2002 by Bastiaan Naber, (C) 2002 by Robert Wittams
email		: bastiaan@ricardis.tudelft.nl
description	: 

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream>
using namespace std;

#include <qstring.h>
#include <qregexp.h> 

#include "apollonsearchviewitem.h"
#include "apollonsearchviewitemchild.h"
#include "apollonutils.h"
#include "giftconnection.h"

ApollonTransferItem::ApollonTransferItem( QListView * parent ) : QListViewItem( parent )
{

}

ApollonTransferItem::ApollonTransferItem( QListViewItem * parent ) : QListViewItem( parent )
{

}

ApollonTransferItem::~ApollonTransferItem()
{
}

QString ApollonTransferItem::text ( int col) const
{
	QString line;	

	switch(col)
	{
		case 0:
			line = file;
        		break;
		case 1:
			line = ApollonUtils::convert_size(size.toULong());
        		break;
		case 2:
			line = QString::number( children.count() ) + i18n(" source(s)");
        		break;
		case 3:
			line = user;
        		break;

	}
	
	return line;
}

QString ApollonTransferItem::key ( int column, bool ascending ) const
{
	switch (column)
	{
		case 0:
			return text(column).lower();
			break;
		case 1:
			return size.rightJustify(15, '0');
			break;
		default:
			return text(column);
			break;
	}
}
