/***************************************************************************
                          Apollontransfertab.h  -  description
                             -------------------
    begin                : Tue Apr 2 2002
    copyright            : (C) 2002 by Robert Wittams
    email                : robert@wittams.com en Je Moeder
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef APOLLONTRANSFERTAB_H
#define APOLLONTRANSFERTAB_H


#include <klistview.h>

#include <qvaluelist.h>

#include "apollonsystemtray.h"
#include "apollontab.h"

class QPopupMenu;
class QTimer;

class giFTConnection;
class ApollonPlayerTab;
class ApollonPreferencesDialog;
class ApollonTransferViewItem;

class ApollonTransferTab : public ApollonTab
{
	Q_OBJECT

	public:
		ApollonTransferTab(QWidget* parent, const char *name, giFTConnection* gcn);
		~ApollonTransferTab();
		void setTray(ApollonSystemTray*);

		inline void setPlayerTab(ApollonPlayerTab *playerTab);
		inline void setPreferences(ApollonPreferencesDialog *preferences);

	public slots:
		void addDownloadViewItem(  QString line);
		void delDownloadViewItem(  QString line);
		void addUploadViewItem(    QString line);
		void delUploadViewItem(    QString line);
		void updateDownloadView(   QString line);
		void updateDownloadSources(QListViewItem *item);
		void updateUploadView(     QString line);
		void updateUploadSources(  QListViewItem *item);
		void addSourceItem(        QString line);
		void ItemReply(            QString line);

		void disconnected();

		void downloadPopup(QListViewItem*, const QPoint&, int);
		void uploadPopup(QListViewItem*, const QPoint&, int col);

		void cancelDownload();
		void cancelUpload();
		void pauseDownload();
		void unpauseDownload();
		void clearFinishedDownloads();
		void clearFinishedUploads();
		void clearAll();

		void previewFile();
		void autoSourceSearch();
		void sourceSearch(bool autoSearch = false);
		void sltBrowseUser();
		void sltGetUserIP(int);
		void setShowPopup(bool);

		void sltAutoSearchInterval(int);

	signals:
		void sigBrowseUser(QString);
		void sigSendInfo(int, float);

	private:
		void clearFinished(ApollonTransferViewItem *item);
		void countActives();

		KListView* uplist;
		KListView* downlist;

		QPopupMenu *downmenu, *upmenu;
		QPopupMenu *browseusermenu;

		int current; // The item currently right-clicked
		QString userIP;
		QValueList<int> sourcesearchids;
		bool showPopup;
		ApollonSystemTray *systemTray;
		ApollonPlayerTab *m_playerTab;
		ApollonPreferencesDialog *m_preferences;
		QTimer *m_sourceSearchTimer;
		int m_autoSearchInterval; // minutes
};

void ApollonTransferTab::setPlayerTab(ApollonPlayerTab *playerTab)
{
	m_playerTab = playerTab;
}

void ApollonTransferTab::setPreferences(ApollonPreferencesDialog *preferences)
{
	m_preferences = preferences;
}

#endif
